;                   Turbo Assembler (Version 1.0 and higher)                  ; ;-This is the comment column ;
;                                                                             ; ; which explains the program ;
;             Comm_TP5.ASM Ver. 2.50 - Comm_TP5 Support Routines              ; ; operation where necessary. ;
;                              (c) Copyright, 1991                            ; ;                            ;
;                               Kevin R. Bulgrien                             ; ; It is likely to cause your ;
;                                January 27, 1999                             ; ; hard copy to exceed a line ;
;                                                                             ; ; width of 80 characters, so ;
; See the accompanying file Comm_TP5.DOC of specific information regarding    ; ; your printer will need to  ;
; distribution policies & supplementary documentation for the source code.    ; ; be set for smaller print.  ;
;                                                                             ; ;                            ;
; Written by:  Kevin R. Bulgrien           Version 2.50 completed 08/06/91    ; ; I hope this is acceptably  ;
;                                                                             ; ; inconvenient as I believe  ;
; Send all correspondance to:              Kevin R. Bulgrien                  ; ; that documentation is far  ;
;                                          P. O. Box 563                      ; ; easier to read when it is  ;
; CompuServe: 102174,1561                  Longview, TX 75606                 ; ; not mingled with the code. ;
; Internet:   kbulgrien@worldnet.att.net   (903) 757-5163                     ; ;                            ;
;                                                                             ; ; No code should be placed   ;
; Also contact via: c/o K. A. Bulgrien, 1700 Sheldon Road, Sandusky, MI 48471 ; ; in this column so that it  ;
;                                                                             ; ; will be easier to remove.  ;
; This code package must always include the following files:  Comm_TP5.PAS,   ; ;                            ;
; Comm_TP5.H, Comm_TP5.ASM, Comm_TPA.OBJ, Comm_TPB.OBJ, Comm_TP5.DOC,         ; ;-When Comm_TPx.OBJ is here, ;
; Comm_IO5.PAS, Comm_IO5.H, and Comm_TTY.PAS.                                 ; ; no need for an assembler.  ;
                                                                                ;                            ;
               .MODEL          TPASCAL                                          ;-Turbo Pascal requirements. ;
                                                                                ;                            ;
               THR             EQU 0       ; Transmit Holding Register          ;-Used to make readable code ;
               RHR             EQU 0       ; Receive Holding Register           ; They provide offsets from  ;
               DLL             EQU 0       ; Divisor Latch Register LSB         ; the base address of the    ;
               IER             EQU 1       ; Interrupt Enable Register          ; UART to the actual         ;
               DLM             EQU 1       ; Divisor Latch Register MSB         ; register needed.           ;
               IIR             EQU 2       ; Interrupt ID Register              ;                            ;
               LCR             EQU 3       ; Line Control Register              ;                            ;
               MCR             EQU 4       ; Modem Control Register             ;                            ;
               LSR             EQU 5       ; Line Status Register               ;                            ;
               MSR             EQU 6       ; Modem Status Register              ;                            ;
                                                                                ;                            ;
IOStats        STRUC                                                            ;-Status variables needed by ;
                                                                                ; each I/O buffer.           ;
               Buffer          DD ?        ; Address of the buffer              ;                            ;
               Head            DW ?        ; Points to next data out            ;-These declarations must    ;
               Tail            DW ?        ; Points to next empty space         ; correspond to the similar  ;
               CurSize         DW ?        ; Items in the buffer                ; declarations in Comm_TP5.H ;
               MaxSize         DW ?        ; Maximum allowable items            ; or else this module will   ;
               CurTime         DW ?        ; Elapsed time counter               ; not function correctly!    ;
               MaxTime         DW ?        ; Maximum time until error           ;                            ;
                                                                                ;                            ;
IOStats        ENDS                                                             ;                            ;
                                                                                ;                            ;
PortType       STRUC                                                            ;-Status variables needed by ;
                                                                                ; each port handler.         ;
               COMAddr         DW ?        ; Base address of the UART           ;                            ;
               COMNmbr         DB ?        ; COM number assigned to port        ;-These declarations must    ;
               IRQNmbr         DB ?        ; IRQ level supporting the port      ; correspond to the similar  ;
               Framing         DW ?        ; I/O error counters                 ; declaration in Comm_TP5.H  ;
               Overrun         DW ?                                             ; or else this module will   ;
               Parity          DW ?                                             ; not function correctly!    ;
               Break           DW ?                                             ;                            ;
               RTS             DB ?        ; Output line status variables       ;                            ;
               DTR             DB ?                                             ;                            ;
               CTS             DB ?        ; Input line status variables        ;                            ;
               DSR             DB ?                                             ;                            ;
               RI              DB ?                                             ;                            ;
               CD              DB ?                                             ;                            ;
               UseRTS          DB ?        ; Enable/Disable use of RTS          ;                            ;
               UseDTR          DB ?        ; Enable/Disable use of DTR          ;                            ;
               OverFlow        DB ?        ; Incoming data overflowed buffer?   ;                            ;
               I               IOStats ?   ; Input buffer related items         ;                            ;
               O               IOStats ?   ; Output buffer related items        ;                            ;
                                                                                ;                            ;
PortType       ENDS                                                             ;                            ;
                                                                                ;                            ;
               EXTRN           MaxPortsInUse : BYTE                             ;-Maximum number of handlers.;
               EXTRN           PortInfo : DWORD                                 ;-Points to port info tables.;
               EXTRN           IRQMask : BYTE                                   ;-Record of installed IRQs.  ;
                                                                                ;                            ;
               .CODE                                                            ;                            ;
                                                                                ; Allows you to reuse labels ;
               LOCALS          @@                                               ;-beginning with symbols @@. ;
                                                                                ;                            ;
IFDEF          ASMInt                                                           ;-This PROC assembles only   ;
                                                                                ; if a /dASMInt is included  ;
SerialInt      PROC            FAR                                              ; on the TASM command line.  ;
               PUBLIC          SerialInt                                        ;                            ;
                                                                                ; Always use the assembly    ;
               PUSH            SI            ; SI = PortInfo Offset             ; language interrupt handler ;
               PUSH            DI            ; DI = General purpose pointer     ; instead of the Pascal one. ;
               PUSH            BP            ; BP = General purpose variable    ; It is much more efficient, ;
               PUSH            ES            ; ES = Comm_TP5 Segment            ; and, allows your programs  ;
               PUSH            DS            ; DS = PortInfo Segment            ; to process data at higher  ;
               PUSH            DX            ; DX = PortInfo []^.COMAddr        ; throughput rates.  Both    ;
               PUSH            CX            ; CL = IRQ, CH = IMR               ; are included to allow non- ;
               PUSH            BX            ; BX = PortInfo []                 ; ASM programmers the option ;
               PUSH            AX            ; AX = General Purpose             ; of modifying the handler.  ;
                                                                                ;                            ;
               SUB             CL,CL                                            ;-Current IRQ is unknown.    ;
               IN              AL,21h                                           ;-Store IMR for later use.   ;
               MOV             CH,AL                                            ;-Request 8259 an ISR read.  ;
               MOV             AL,0Bh                                           ;                            ;
               OUT             20h,AL                                           ;                            ;
               IN              AL,20h                                           ;-Get the 8259 ISR value     ;
@@FindIRQ:     TEST            AL,01h                                           ;-Upon loop completion, CL   ;
               JNZ             SHORT @@KnowIRQ                                  ; will contain the IRQ # of  ;
               SHR             AL,1                                             ; the interrupt in progress. ;
               INC             CL                                               ;                            ;
               JMP             SHORT @@FindIRQ                                  ;                            ;
                                                                                ;                            ;
@@KnowIRQ:     MOV             AL,BYTE PTR IRQMask                              ;-Disable all other Comm_TP5 ;
               OR              AL,CH                                            ; IRQ levels while this one  ;
               OUT             21h,AL                                           ; is active.                 ;
               STI                                                              ;-Turn other interrupts on.  ;
               MOV             AX,CS:Comm_TP5_DS                                ;-Get the Comm_TP5 segment   ;
               MOV             ES,AX                                            ; and place it in ES.        ;
               MOV             BL,ES:MaxPortsInUse                              ;-Find the maximum number of ;
               INC             BL                                               ; ports Comm_TP5 supports, & ;
               MOV             CS:BYTE PTR @@ID,BL                              ; save to a loop variable.   ;
               MOV             BX,OFFSET PortInfo                               ;-Find pointer array address.;
@@CheckPort:   DEC             CS:BYTE PTR @@ID                                 ;-Process all ports on the   ;
               JNZ             SHORT @@NotDone                                  ; IRQ level which invoked    ;
               JMP             @@Finished                                       ; this interrupt.            ;
                                                                                ;                            ;
@@ID           DB              00h                                              ;-Local loop control variable;
                                                                                ;                            ;
@@NotDone:     MOV             SI,ES:WORD PTR [BX]                              ;-Get segment:offset of the  ;
               ADD             BX,0002h                                         ; port handler table for     ;
               MOV             AX,ES:WORD PTR [BX]                              ; this port.                 ;
               MOV             DS,AX                                            ;                            ;
               ADD             BX,0002h                                         ;                            ;
               OR              AX,SI                                            ;-If 0:0, the handler is not ;
               JZ              SHORT @@CheckPort                                ; installed so check another.;
               CMP             BYTE PTR [SI+PortType.IRQNmbr],CL                ;-Handler installed.  Only   ;
               JNZ             SHORT @@CheckPort                                ; continue if same IRQ.      ;
               MOV             DX,WORD PTR [SI+PortType.COMAddr]                ;-Get UART base address for  ;
               PUSH            DX                                               ; this port handler & save.  ;
               ADD             DX,LCR                                           ;                            ;
               IN              AL,DX                                            ; Write to the LCR register  ;
               AND             AL,7Fh                                           ; to be sure that RHR/THR,   ;
               OUT             DX,AL                                            ;-and IER are accessible.    ;
               DEC             DX                                               ;                            ;
               IN              AL,DX                                            ;-Read IIR to identify any   ;
               TEST            AL,01h                                           ; pending interrupts.        ;
               JNZ             @@NoInterrupt                                    ;                            ;
               AND             AL,06h                                           ;-Calculate offset into the  ;
               SUB             AH,AH                                            ; jump table so that the     ;
               MOV             DI,AX                                            ; right handler is run.      ;
               JMP             WORD PTR CS:[DI+@@Case]                          ;-Go to appropriate handler. ;
                                                                                ;                            ;
@@NoInterrupt: POP             DX                                               ;-Clear stack & check next   ;
               JMP             @@CheckPort                                      ; handler if no interrupts   ;
                                                                                ; were pending on this one.  ;
@@Case         DW              @@Modem                                          ;                            ;
               DW              @@Transmit                                       ;-Jump table pointing to the ;
               DW              @@Receive                                        ; handlers for individual    ;
               DW              @@Line                                           ; interrupt types.           ;
                                                                                ;                            ;
@@Line:        POP             DX                                               ;-Restore UART base address. ;
               ADD             DX,LSR                                           ;                            ;
               IN              AL,DX                                            ;-Read current line status.  ;
               TEST            AL,02h                                           ;                            ;
               JZ              @@NoOverrun                                      ; Check for each line status ;
               INC             WORD PTR [SI+PortType.Overrun]                   ; error type (Overrun/Parity ;
@@NoOverrun:   TEST            AL,04h                                           ; Framing/Break).  Increment ;
               JZ              @@NoParity                                       ; the corresponding error    ;
               INC             WORD PTR [SI+PortType.Parity]                    ; counter for each error     ;
@@NoParity:    TEST            AL,08h                                           ; detected.                  ;
               JZ              @@NoFraming                                      ;                            ;
               INC             WORD PTR [SI+PortType.Framing]                   ;                            ;
@@NoFraming:   TEST            AL,10h                                           ;                            ;
               JZ              @@NoBreak                                        ;                            ;
               INC             WORD PTR [SI+PortType.Break]                     ; End of line status change  ;
@@NoBreak:     JMP             @@CheckPort                                      ;-handler.  Check next port. ;
                                                                                ;                            ;
@@Receive:     MOV             AX,WORD PTR [SI+PortType.I.Tail]                 ;-Receive register full.  If ;
               MOV             DI,AX                                            ; (Tail + 1) MOD MaxSize =   ;
               INC             AX                                               ; Head, the buffer is full.  ;
               SUB             DX,DX                                            ; Calculate new Tail while   ;
               DIV             WORD PTR [SI+PortType.I.MaxSize]                 ; remembering the old one.   ;
               MOV             BP,DX                                            ;                            ;
               POP             DX                                               ;-Restore UART base address. ;
               IN              AL,DX                                            ;-Read the available data.   ;
               CMP             BP,WORD PTR [SI+PortType.I.Head]                 ;-Check if buffer is full.   ;
               JZ              SHORT @@QueueFull                                ;                            ;
               PUSH            ES                                               ;-Temporarily used to access ;
               PUSH            BX                                               ; the buffer contents.       ;
               MOV             BX,DI                                            ;-DI is current Tail pointer.;
               MOV             DI,WORD PTR [SI+PortType.I.Buffer]               ;-BX is offset of the buffer.;
               MOV             DX,WORD PTR [SI+PortType.I.Buffer+2]             ;-ES is the buffer segment.  ;
               MOV             ES,DX                                            ;                            ;
               MOV             BYTE PTR ES:[DI+BX],AL                           ;-Put the data in the buffer.;
               POP             BX                                               ;-Restore old environment.   ;
               POP             ES                                               ;                            ;
               MOV             WORD PTR [SI+PortType.I.Tail],BP                 ;-Adjust the Tail pointer.   ;
               INC             WORD PTR [SI+PortType.I.CurSize]                 ;-Increment current buffer   ;
               JMP             @@CheckPort                                      ; size and check next port.  ;
                                                                                ;                            ;
@@QueueFull:   MOV             BYTE PTR [SI+PortType.OverFlow],01h              ;-If buffer was full, log an ;
               JMP             @@CheckPort                                      ; overflow and continue.     ;
                                                                                ;                            ;
@@Transmit:    POP             DX                                               ;-Restore UART base address  ;
               MOV             BP,WORD PTR [SI+PortType.O.Head]                 ;-If Head = Tail, there is   ;
               CMP             BP,WORD PTR [SI+PortType.O.Tail]                 ; no data to send, so turn   ;
               JZ              @@Disable                                        ; transmit interrupt off.    ;
               PUSH            ES                                               ;-Temporarily used to access ;
               PUSH            BX                                               ; the buffer contents.       ;
               MOV             DI,WORD PTR [SI+PortType.O.Buffer]               ;-DI is the buffer offset.   ;
               MOV             BX,WORD PTR [SI+PortType.O.Buffer+2]             ;-ES is the buffer segment.  ;
               MOV             ES,BX                                            ;                            ;
               MOV             BX,BP                                            ;-Get the data located at    ;
               MOV             AL,ES:BYTE PTR [DI+BX]                           ; the Head of the buffer.    ;
               POP             BX                                               ;-Restore old environment.   ;
               POP             ES                                               ;                            ;
               OUT             DX,AL                                            ;-Send the data, and update  ;
               MOV             AX,BP                                            ; the head to (Head + 1) MOD ;
               INC             AX                                               ; MaxSize.                   ;
               SUB             DX,DX                                            ;                            ;
               DIV             WORD PTR [SI+PortType.O.MaxSize]                 ;                            ;
               MOV             WORD PTR [SI+PortType.O.Head],DX                 ;                            ;
               DEC             WORD PTR [SI+PortType.O.CurSize]                 ;                            ;
               JMP             @@CheckPort                                      ;-Check the next port.       ;
                                                                                ;                            ;
@@Disable:     INC             DX                                               ;-If the buffer was empty,   ;
               IN              AL,DX                                            ; turn off the transmit      ;
               AND             AL,0FDh                                          ; interrupt.                 ;
               OUT             DX,AL                                            ;                            ;
               JMP             @@CheckPort                                      ;-Check the next handler.    ;
                                                                                ;                            ;
@@Modem:       POP             DX                                               ;-Restore UART base address. ;
               ADD             DX,MSR                                           ;-Read the current state of  ;
               IN              AL,DX                                            ; the UART input lines (CD   ;
               MOV             DX,0100h                                         ; CTS/DSR/RI).               ;
               TEST            AL,80h                                           ;                            ;
               JNZ             @@CDOn                                           ; For each line, set the     ;
               MOV             BYTE PTR [SI+PortType.CD],DL                     ; handler status variables   ;
               JMP             @@SetCTS                                         ; TRUE or FALSE depending    ;
@@CDOn:        MOV             BYTE PTR [SI+PortType.CD],DH                     ; on the current line        ;
@@SetCTS:      TEST            AL,10h                                           ; state.                     ;
               JNZ             @@CTSOn                                          ;                            ;
               MOV             BYTE PTR [SI+PortType.CTS],DL                    ; DH = TRUE                  ;
               JMP             @@SetDSR                                         ; DL = FALSE                 ;
@@CTSOn:       MOV             BYTE PTR [SI+PortType.CTS],DH                    ;                            ;
@@SetDSR:      TEST            AL,20h                                           ;                            ;
               JNZ             @@DSROn                                          ;                            ;
               MOV             BYTE PTR [SI+PortType.DSR],DL                    ;                            ;
               JMP             @@SetRI                                          ;                            ;
@@DSROn:       MOV             BYTE PTR [SI+PortType.DSR],DH                    ;                            ;
@@SetRI:       TEST            AL,40h                                           ;                            ;
               JNZ             @@RIOn                                           ;                            ;
               MOV             BYTE PTR [SI+PortType.RI],DL                     ;                            ;
               JMP             @@CheckPort                                      ;                            ;
@@RIOn:        MOV             BYTE PTR [SI+PortType.RI],DH                     ; Done with Modem status, so ;
               JMP             @@CheckPort                                      ;-go on and check next port. ;
                                                                                ;                            ;
@@Finished:    CLI                                                              ;-Done, shut off interrupts  ;
               MOV             AL,CH                                            ; while restoring 8259 IMR.  ;
               OUT             21h,AL                                           ;                            ;
               MOV             AL,20h                                           ;-Signal the 8259 that a non ;
               OUT             20h,AL                                           ; specific end of interrupt  ;
                                                                                ; has now occurred.          ;
               POP             AX                                               ;                            ;
               POP             BX                                               ;-Restore all registers used ;
               POP             CX                                               ; by the interrupt handler.  ;
               POP             DX                                               ; Note that the use of all   ;
               POP             DS                                               ; registers instead of RAM   ;
               POP             ES                                               ; variables will help the    ;
               POP             BP                                               ; interrupt to be much       ;
               POP             DI                                               ; faster.                    ;
               POP             SI                                               ;                            ;
               IRET                                                             ;-Return to main program.    ;
                                                                                ;                            ;
SerialInt      ENDP                                                             ;                            ;
                                                                                ;                            ;
ENDIF                                                                           ;                            ;
                                                                                ;                            ;
TimerInt       PROC            FAR                                              ;-Hooks in to BIOS interrupt ;
                                                                                ; 1Ch to provide port timers.;
               PUSH            AX                                               ;-AX is for general purposes.;
               PUSH            BX                                               ;-BX points into PortInfo.   ;
               PUSH            CX                                               ;-CX controls handler loop.  ;
               PUSH            DS                                               ;-DS is copy of PortInfo [?].;
               PUSH            ES                                               ;-ES is Comm_TP5 data segment;
               PUSH            SI                                               ;-SI is offset to port table.;
               MOV             AX,CS:Comm_TP5_DS                                ;-Find Comm_TP5's DS value.  ;
               MOV             ES,AX                                            ;                            ;
               SUB             CH,CH                                            ;                            ;
               MOV             CL,ES:MaxPortsInUse                              ;-Get # of Comm_TP5 handlers.;
               MOV             BX,OFFSET PortInfo                               ;-Find offset of handler     ;
@@Addr:        MOV             SI,ES:WORD PTR [BX]                              ; pointer array.             ;
               ADD             BX,2                                             ;-Get the Segment:Offset of  ;
               MOV             AX,ES:WORD PTR [BX]                              ; the current port handler   ;
               MOV             DS,AX                                            ; information table.         ;
               ADD             BX,2                                             ;                            ;
               OR              AX,SI                                            ; Skip this handler if it is ;
               JZ              SHORT @@Loop                                     ;-not currently installed.   ;
@@ISet:        MOV             AX,[SI+PortType.I.CurTime]                       ;                            ;
               INC             AX                                               ;-Increment the input timer. ;
               JZ              SHORT @@IZero                                    ; If it reaches 0FFFFh, do   ;
@@IEnd:        MOV             [SI+PortType.I.CurTime],AX                       ; not allow it to wrap to 0. ;
@@OSet:        MOV             AX,[SI+PortType.O.CurTime]                       ;                            ;
               INC             AX                                               ;-Increment the output timer ;
               JZ              SHORT @@OZero                                    ; If it reaches 0FFFFh, do   ;
@@OEnd:        MOV             [SI+PortType.O.CurTime],AX                       ; not allow it to wrap to 0. ;
               MOV             AX,[SI+PortType.O.CurSize]                       ;                            ;
               AND             AX,AX                                            ;-If there are no characters ;
               JZ              SHORT @@Loop                                     ; in output buffer, do not   ;
               PUSH            DX                                               ; try to start interrupt.    ;
               MOV             DX,[SI+PortType.COMAddr]                         ;                            ;
               ADD             DX,IER                                           ;-DX temporarily points to   ;
               IN              AL,DX                                            ; UART registers (now IER).  ;
               AND             AL,02h                                           ;-If the interrupt already   ;
               JNZ             SHORT @@PopDX                                    ; is on, skip this section.  ;
               ADD             DX,LSR-IER                                       ;-DX points to LSR now.      ;
               IN              AL,DX                                            ;-If the transmit buffer is  ;
               AND             AL,20h                                           ; not empty yet, do not try  ;
               JZ              SHORT @@PopDX                                    ; to start the interrupt.    ;
               SUB             DX,LSR-IER                                       ;-DX points to IER now.      ;
               IN              AL,DX                                            ;-Start up the transmitter   ;
               OR              AL,02h                                           ; now by rewriting the IER.  ;
               OUT             DX,AL                                            ;                            ;
               SUB             DX,IER-THR                                       ;-DX points to THR now.      ;
               PUSH            BX                                               ;-Save any registers needed  ;
               PUSH            DI                                               ; to start the transmitter.  ;
               PUSH            ES                                               ;                            ;
               MOV             DI,WORD PTR [SI+PortType.O.Buffer]               ;-DI is offset of buffer.    ;
               MOV             AX,WORD PTR [SI+PortType.O.Buffer+2]             ;                            ;
               MOV             ES,AX                                            ;-ES is segment of buffer.   ;
               MOV             BX,[SI+PortType.O.Head]                          ;-BX is the Head pointer.    ;
               MOV             AL,ES:[DI+BX]                                    ;                            ;
               OUT             DX,AL                                            ;-Put first character in the ;
               INC             BX                                               ; THR to start the interrupt.;
               CMP             BX,[SI+PortType.O.MaxSize]                       ;                            ;
               JNE             SHORT @@NoWrap                                   ;-Adjust the Head pointer &  ;
               SUB             BX,BX                                            ; wrap around to 0 when end  ;
@@NoWrap:      MOV             [SI+PortType.O.Head],BX                          ; of buffer is reached.      ;
               DEC             WORD PTR [SI+PortType.O.CurSize]                 ;                            ;
               POP             ES                                               ;-Restore registers used to  ;
               POP             DI                                               ; start the transmitter.     ;
               POP             BX                                               ;                            ;
@@PopDX:       POP             DX                                               ; Process the next port      ;
@@Loop:        LOOP            SHORT @@Addr                                     ;-handler until all are done.;
               POP             SI                                               ;                            ;
               POP             ES                                               ;-Restore all modified       ;
               POP             DS                                               ; registers as we are done   ;
               POP             CX                                               ; processing the ports.      ;
               POP             BX                                               ;                            ;
               POP             AX                                               ;                            ;
               DB              0EAh                                             ;-Jump directly to the BIOS  ;
OldVect        DW              0                                                ; timer interrupt that we    ;
OldVectSeg     DW              0                                                ; hooked into. It will IRET. ;
                                                                                ;                            ;
Comm_TP5_DS    DW              0                                                ;-Stored copy of Comm_TP5 DS.;
                                                                                ;                            ;
@@IZero:       DEC             AX                                               ;-Insures that the input and ;
               JMP             SHORT @@IEnd                                     ; output elapsed time count  ;
@@OZero:       DEC             AX                                               ; does not wrap to 0.  This  ;
               JMP             SHORT @@OEnd                                     ; allows for infinite waits. ;
                                                                                ;                            ;
TimerInt       ENDP                                                             ;                            ;
                                                                                ;                            ;
InstallTimer   PROC            FAR                                              ;-A special install needed   ;
               PUBLIC          InstallTimer                                     ; to save DS and old vector. ;
                                                                                ;                            ;
               PUSH            AX                                               ;-Save any registers used.   ;
               PUSH            BX                                               ;                            ;
               PUSH            ES                                               ;-Be sure to save the DS for ;
               MOV             AX,DS                                            ; the interrupt handlers use.;
               MOV             CS:Comm_TP5_DS,AX                                ;                            ;
               MOV             AH,35h                                           ;-Reading old segment/offset ;
               MOV             AL,1Ch                                           ; for the old BIOS interrupt.;
               INT             21h                                              ;                            ;
               MOV             CS:WORD PTR OldVect,BX                           ;-Save old vector for 1Ch.   ;
               MOV             CS:WORD PTR OldVectSeg,ES                        ;                            ;
               MOV             AH,25h                                           ;-Setting new vector for 1Ch.;
               MOV             AL,1Ch                                           ;                            ;
               LEA             DX,TimerInt                                      ;-Get the segment and offset ;
               MOV             BX,CS                                            ; of the new timer interrupt.;
               PUSH            DS                                               ;                            ;
               MOV             DS,BX                                            ; Hook this TimerInt into    ;
               INT             21h                                              ;-the old BIOS interrupt 1Ch.;
               POP             DS                                               ;                            ;
               POP             ES                                               ;-Restore any registers used.;
               POP             BX                                               ;                            ;
               POP             AX                                               ;                            ;
               RET                                                              ;-Installation is completed. ;
                                                                                ;                            ;
InstallTimer   ENDP                                                             ;                            ;
                                                                                ;                            ;
RemoveTimer    PROC            FAR                                              ;-Could be done in Pascal,   ;
               PUBLIC          RemoveTimer                                      ; but more balanced this way.;
                                                                                ;                            ;
               PUSH            AX                                               ;-Save any registers used.   ;
               PUSH            BX                                               ;                            ;
               PUSH            DX                                               ;                            ;
               MOV             AH,25h                                           ;-Reload the segment/offset  ;
               MOV             AL,1Ch                                           ; of the old interrupt in    ;
               MOV             BX,CS:WORD PTR OldVectSeg                        ; place when we hooked into  ;
               PUSH            DS                                               ; it with InstallTimer.      ;
               MOV             DS,BX                                            ;                            ;
               MOV             DX,CS:WORD PTR OldVect                           ;                            ;
               INT             21h                                              ;                            ;
               POP             DS                                               ;-Restore any changed        ;
               POP             DX                                               ; register values.           ;
               POP             BX                                               ;                            ;
               POP             AX                                               ; The interrupt handler is   ;
               RET                                                              ;-now completly uninstalled. ;
                                                                                ;                            ;
RemoveTimer    ENDP                                                             ;                            ;
                                                                                ;                            ;
               END                                                              ;-End of Comm_TP5.ASM        ;
