{               INTERFACE section include file for Comm_TP5.PAS               } {-This is the comment column }
{                                                                             } { which explains the program }
{          Comm_TP5.H Ver. 2.50 - RS-232 Support for IBM Compatibles          } { operation where necessary. }
{                       (c) Copyright, 1989, 1990, 1991                       } {                            }
{                              Kevin R. Bulgrien                              } { It is likely to cause your }
{                               January 27, 1999                              } { hard copy to exceed a line }
{                                                                             } { width of 80 characters, so }
{ See the accompanying file Comm_TP5.DOC of specific information regarding    } { your printer will need to  }
{ distribution policies & supplementary documentation for the source code.    } { be set for smaller print.  }
{                                                                             } {                            }
{ Written by:  Kevin R. Bulgrien           Version 2.50 completed 08/06/91    } { I hope this is acceptably  }
{                                                                             } { inconvenient as I believe  }
{ Send all correspondance to:              Kevin R. Bulgrien                  } { that documentation is far  }
{                                          P. O. Box 563                      } { easier to read when it is  }
{ CompuServe: 102174,1561                  Longview, TX 75606                 } { not mingled with the code. }
{ Internet:   kbulgirien@worldnet.att.net  (903) 757-5163                     } {                            }
{                                                                             } { No code should be placed   }
{ Also contact via: c/o K. A. Bulgrien, 1700 Sheldon Road, Sandusky, MI 48471 } { in this column so that it  }
{                                                                             } { will be easier to remove.  }
{ This code package must always include the following files:  Comm_TP5.PAS,   } {                            }
{ Comm_TP5.H, Comm_TP5.ASM, Comm_TPA.OBJ, Comm_TPB.OBJ, Comm_TP5.DOC,         } {-When Comm_TPx.OBJ is here, }
{ Comm_IO5.PAS, Comm_IO5.H, and Comm_TTY.PAS.                                 } { no need for an assembler.  }
                                                                                {                            }
CONST                                                                           {                            }
  MaxPorts = 2;                                                                 {-Max supported port handlers}
  MaxBuffSize = 65519;                                                          {-Turbo's max data structure }
                                                                                {                            }
  THR = 0; { Transmit Holding Register  }   IIR = 2; { Interrupt ID Register  } {-Used to make readable code }
  RHR = 0; { Receive Holding Register   }   LCR = 3; { Line Control Register  } { EG. A Line Status Register }
  DLL = 0; { Divisor Latch Register LSB }   MCR = 4; { Modem Control Register } { value is read with: PORT   }
  IER = 1; { Interrupt Enable Register  }   LSR = 5; { Line Status Register   } { [PortInfo[PortID]^.COMAddr }
  DLM = 1; { Divisor Latch Register MSB }   MSR = 6; { Modem Status Register  } { +LSR];                     }
                                                                                {                            }
  Receive = 1;      { Used to build the }                                       {-Constants used to identify }
  Transmit = 2;     { Mode value needed }                                       { interrupt types used by    }
  LineStatus = 4;   { by InstallInt to  }                                       { the Comm_TP5 unit.         }
  ModemStatus = 8;  { select interrupts }                                       {                            }
                                                                                {                            }
  ComAddress : ARRAY [0..4] OF WORD = ( 4, $03F8, $02F8, $03E8, $02E8 );        {-Base addresses 8250 Regs   }
  ComIRQNmbr : ARRAY [0..4] OF BYTE = ( 4,     4,     3,     4,     3 );        {-IRQ numbers of the ports   }
                                                                                { (Both are by COM number)   }
  BaudTable : ARRAY [0..9] OF WORD = ($0417, $0300, $0180,                      {                            }
                                      $00C0, $0060, $0030,                      {-Table of constants written }
                                      $0018, $000C, $0006, $0003);              { to DLL & DLM to set baud.  }
                                                                                {                            }
  BaudName : ARRAY [0..9] OF STRING [5] = ('110',  '150',  '300',               {-Strings corresponding to   }
                                           '600',  '1200', '2400',              { the baud rate constants in }
                                           '4800', '9600', '19200','38400');    { Baud Table (Info Only).    }
                                                                                {                            }
  PrtyName : ARRAY [0..7] OF STRING [7] = ('NONE', 'ODD', 'NULL','EVEN',        {-Table of names given to    }
                                           'NOMARK','MARK','NOSPACE','SPACE');  { all possible parity types. }
                                                                                {                            }
TYPE  BaudType = (B110,B150,B300,B600,B1200,B2400,B4800,B9600,B19200,B38400);   {-Baud rates supported       }
      PrtyType = (None, Odd, Null, Even, MarkOff, Mark, SpaceOff, Space);       {-Parity types supported     }
      BuffType = ARRAY [0..MaxBuffSize] OF BYTE;                                {-Type for in/output buffers }
      ProcNameType = STRING [20];                                               {-Type to ID error locations }
      IOStats  = RECORD                                                         {-Status variables needed by }
                   Buffer : ^BuffType;                                          { each Input and Output      }
                   Head, Tail, Size, MaxSize, Time, MaxTime : WORD;             { channel.                   }
                 END;                                                           {                            }
      PortType = RECORD                                                         {-Port handler status vars   }
                   COMAddr : WORD;                                              {-Base address of port       }
                   COMNmbr, IRQNmbr : BYTE;                                     {-COM & IRQ numbers of port  }
                   Framing, Overrun, Parity, Break : WORD;                      {-Port I/O error counters    }
                   RTS, DTR, CTS, DSR, RI, CD : BOOLEAN;                        {-Port I/O line status       }
                   UseRTS, UseDTR : BOOLEAN;                                    {-Output line control vars   }
                   OverFlow : BOOLEAN;                                          {-TRUE if input is lost      }
                   I, O : IOStats;                                              {-In/Output specific items   }
                 END;                                                           {                            }
                                                                                {                            }
CONST DefaultPortInfo : PortType = ( COMAddr : 0;                               {-The default port settings. }
                                     COMNmbr : 0; IRQNmbr : 0;                  { Only certain values can be }
                                     Framing:0; Overrun:0; Parity:0; Break:0;   { effectively set here:      }
                                     RTS : FALSE; DTR : FALSE; CTS : FALSE;     {                            }
                                     DSR : FALSE; RI : FALSE; CD : FALSE;       {    UseRTS, UseDTR, and     }
                                     UseRTS : TRUE; UseDTR : TRUE;              {    MaxTime.                }
                                     OverFlow : FALSE;                          {                            }
                                     I : ( Buffer : NIL;                        { Other values over-written, }
                                           Head : 0; Tail : 0;                  { or must be set to certain  }
                                           Size : 0; MaxSize : 0;               { values to function right.  }
                                           Time : 0; MaxTime : $FFFF );         { MaxTime = $FFFF means the  }
                                     O : ( Buffer : NIL;                        { port will never time out.  }
                                           Head : 0; Tail : 0;                  { Otherwise, MaxTime/18.2 is }
                                           Size : 0; MaxSize : 0;               { the number of seconds for  }
                                           Time : 0; MaxTime : $FFFF ) );       {-the port to time out.      }
                                                                                {                            }
VAR   PortInfo : ARRAY [0..MaxPorts-1] OF ^PortType;                            {-Points to port info tables }
      PortsInUse, MaxPortsInUse : BYTE;                                         {-# of port handlers in use  }
      {$IFDEF ErrorChecking}                                                    {                            }
        ErrorCode, ErrorPort : BYTE;                                            {-Error type code & port     }
        {$IFNDEF NoErrorMsgs}                                                   {                            }
          ErrMsgX, ErrMsgY : BYTE;                                              {-Error message coordinates  }
          ShowMessages : BOOLEAN;                                               {-Enable/Disable err msgs    }
        {$ENDIF}                                                                {                            }
      {$ENDIF}                                                                  {                            }
                                                                                {                            }
PROCEDURE EnableInts; INLINE ($FB);                                             {-Enable hardware interrupts }
PROCEDURE DisableInts; INLINE ($FA);                                            {-Disable hardware interrupts}
{$IFDEF ErrorChecking}                                                          {                            }
  PROCEDURE MakeError (Code : Byte; Port : SHORTINT; ProcName : ProcNameType);  {-Handles Comm_TP5 errors    }
  FUNCTION ValidPort (Port : SHORTINT; ProcName : ProcNameType) : BOOLEAN;      {-Check port handle validity }
{$ENDIF}                                                                        {                            }
FUNCTION  InstallInt (Mode:BYTE;Com,IRQ:BYTE;Addr,ISize,OSize:WORD) : SHORTINT; {-Install a port handler     }
PROCEDURE RemoveInt (ID : SHORTINT);                                            {-Remove a port handler      }
PROCEDURE SetRtsDtr (ID, NewRTS, NewDTR : SHORTINT);                            {-Set port output lines      }
PROCEDURE EmptyBuffer (ID : SHORTINT; TrueInFalseOut : BOOLEAN);                {-Clear port handler buffers }
PROCEDURE SetCOMPort (ID : SHORTINT; Baud, DBit, Prty, SBit : BYTE);            {-Set port parameters        }
PROCEDURE GetCOMPort (ID : SHORTINT; VAR Baud, DBit, Prty, SBit : BYTE);        {-Get port parameters        }
